/*
//Function: Add an entry at the right place of the table
//Parameters:
// 1. tblid: table id
// 2. text: the text which will appear in the first cell of the appended row
// 3. imgpath: the path of the "trash" image which is in the second cell of the appended row
// 4. sltOptionid: the id of the control "slection" which lists all the options we can choose
// 5. btnAdd: the "add" button which stays in-between 
// 6. mode: 'ReadOnly' or not
// 7. option: sort options 'ascending' or 'descending'

//Comments: the difficulty in this function is the bindding of event handler for the "trash" image;
//          I tried a whole day because of the syntax error, and it is very special for strings as //          its parameters. Be careful! 
*/
function addEntry(tblid,text,imgpath,sltOptionid,btnAddid,mode,option){
/* if the text is null, noting would be added into the table	*/
    if (text==null) return false;

/* obtain the table object from its id*/
    var tbl= document.getElementById(tblid);

    
    var tblIndex=SortTable(tbl, text, option);


/*insert a row, and return the handle of the added row*/
    var row = tbl.insertRow(tblIndex);
    
/* insert the left text cell into the row, and return the handle of cell*/
    // left cell
    var cellLeft = row.insertCell(0);

/* determine the class of the row, differnt class has different colors. There are only two(2) colors here in this talbe*/
    cellLeft.className='data'+whichClass(2,tblIndex)+'b';  
    
/*create a text node for the cell,fill in the text, and return the handle*/
    var textNode = document.createTextNode(text);

/* append the text node into the cell*/    
    cellLeft.appendChild(textNode);

/*likewise*/   
    var cellRight = row.insertCell(1);
    cellRight.className='data'+whichClass(2,tblIndex);   // The module parameters

/* re-assign the color of all the entries after insertion*/
	reAssigncolor(tblid);


if (mode!='ReadOnly')
{	
/*create an element (an image here)*/
    var el = document.createElement('input');
    el.setAttribute('type', 'image');
    el.setAttribute('align', "center");
    //el.setAttribute('name', 'imginRow' + iteration);
    el.setAttribute('src', imgpath);
    el.setAttribute('width', 18);
    el.setAttribute('height',18);

/*binding the "onclick" event handler for the image
 There are four functions:
 1. removeRowFromTable: remove the row from the table
 2. NeedRecoverBntid: judge if the "add" button should change status: enabled or disabled
    if the current selected option in the selection control is right the same as the entry which
    has been deleted, we should enable the "add" button (it was disabled)
    otherwise, no change for "add" button.
 3. RecoverBtn: change the status of button if needed.
 4. reAssigncolor:reAssign the color of each entry, because we should make colors of neighbors     different. 
 Comments: There is a parameter problem as mentioned above.Be careful.
*/
    el.onclick=Function("removeRowFromTable('"+text+"','"+tblid+"');"+"NeedRecoverBntid(        '"+text+"','"+sltOptionid+"','"+btnAddid+"');"+"reAssigncolor('"+tblid+"')");

   


/* Append the element into the cell*/    
    cellRight.appendChild(el);
}    
/* return true if a row added*/
    return true;

  }

//Re-assign the colors of each row after the table updated (delete a row)
//tblid: table id
function reAssigncolor(tblid)
{
    var tbl= document.getElementById(tblid);
    var lastRow = tbl.rows.length;
        
    for (i=1;i<lastRow;i++)
     {  /* should assign the colors for both cells in the row*/
        tbl.rows[i].cells[0].className='data'+whichClass(2,i)+'b';
	tbl.rows[i].cells[1].className='data'+whichClass(2,i);
		
     }
}

// the color for the row of the table
//module: how many different classes
//row: current row number
//return: the class number
function whichClass(module, row)
{
	return (row+1)%module+1;
	
}

// remove the row whose text in the first cell is the same as text
// text: the one will be removed
// tblid: table id
// return: the text removed (not used in the program)

/*Comments: I was using 'innerText' instead of 'innerHtml' before, however, the 
aweful thing is that 'innerText' is not defined in netscape. Therefore, I use 'innerHTML'
*/
function removeRowFromTable(text,tblid)
{
     var tbl = document.getElementById(tblid);
     var lastRow = tbl.rows.length;

 // Search the matched one in the talbe    
     for (i=1;i<lastRow;i++)
     {
        if (tbl.rows[i].cells[0].innerHTML==text)
	{
		tbl.deleteRow(i);
		break;
	}	
     }
     return text;
}

//judge if the status of 'Add' button need to be changed
//text: the text which has just been removed
//sltoptionid: the id of the 'slection'control 
//btnTargetid: the id of the 'Add' button
/* The approach here is comparing the current selected text in 'selection' contol to the text has
 just been removed. if equal, need to enable the button (because the button is disabled when they are same , whcih avoids duplication), otherwise no need
*/
function NeedRecoverBntid(text, sltOptionid,btnTargetid)
{

	var opt= document.getElementById(sltOptionid);
        var btnid= document.getElementById(btnTargetid);

	// if the current selected one is the same as the one just deleted, recover the button
	if (opt.options[opt.selectedIndex].text==text)
		btnid.disabled=false;

}
/* the same function as the above one, the difference here is by name not by id of the 'selection'
   so is the button
   The reason why there are two functions here , because I don't know how to put this function into    the "onclick" event handler binding of the "trash" image(discussed above).I can't figure out the    syntax error there. Because the parameters' combination (text and non-text). I can only do
   (non-text,non-text) or (text,text). Let me know if you figure it out.
*/
function NeedRecoverBnt(text, sltOption,btnTarget)
{
	
	if (sltOption.options[sltOption.selectedIndex].text==text)
		btnTarget.disabled=false;
}

/* recover the button status if needed, discussed above
   btnTargetid: id of the 'add' button
   boolrev: the return value from function 'NeedRecoverBnt'
   ATTENTION: this function is not used 
*/
function RecoverBtnid(btnTargetid, boolrev)
{
	var btnid= document.getElementById(btnTargetid);
	if (boolrev)
		btnid.disabled=false;
	
}

/* recover the button status if needed, discussed above
   btnTarget: name of the 'add' button
   boolrev: the return value from function 'NeedRecoverBnt'
   ATTENTION: this function is not used
*/
function RecoverBtn(btnTarget, boolrev)
{
	if (boolrev)
		btnTarget.disabled=false;
	
}


/*This function is used to enable or disable the button
'Add'
   btnTarget: name of the 'add' button
   boolrev: value of the status (true or false)
*/
function DsblEnblButton(btnTarget, boolDup)
{
	btnTarget.disabled=boolDup;		
}




/*This function is for checking if the current selected option in the selection button is the duplication of an addresses in the table
if is, disable the 'add' button. otherwise enable it

reason:For avoding duplications

txtOption: current selected text of the 'selection' control
tblid: id of the table
*/

/*Comments: I was using 'innerText' instead of 'innerHtml' before, however, the 
aweful thing is that 'innerText' is not defined in netscape. Therefore, I use 'innerHTML'
*/
function isDuplicated(txtOption,tblid)
{
 
     if (txtOption==null) return false;


     var boolDup=false;
     var tbl = document.getElementById(tblid);
     var lastRow = tbl.rows.length;
 
    // Search the matched one in the talbe    
     for (i=1;i<lastRow;i++)
     {
      if (tbl.rows[i].cells[0].innerHTML==txtOption)
	{
		boolDup=true;
		break;
	}	
     }

     return boolDup;

		
}

/*see if we have already selected an option in the selection ctrl
ctlSelect: the 'selection' ctrl

return the selected text if an option selected, otherwise return null
*/
function OptSelected(ctlSelect)
{
    if (ctlSelect.length>0)
      {		
	if ( ctlSelect.selectedIndex!=-1)
	
		return ctlSelect.options[ctlSelect.selectedIndex].text;
	
	else
		return null;
      }else
      	return null;
}


/*
	insertion sort the entries in the table either decending or ascending
	
	tblid: talbe id
	text: the contents to be inserted;
	option: 'ascending' or 'descending', otherwise put the new entry at the end
	
	return the entry index to be used for insertion
*/
function SortTable(tbl, text, option)
{

/* get the current total row number of the table, including the title row
 and the minimum number is 1--the title*/
    var lastRow = tbl.rows.length;

// No entry yet
    if (lastRow==1) return 1;

    if (option=='ascending')
    	{
		 for (i=1;i<lastRow;i++)
     		 {
      			if (tbl.rows[i].cells[0].innerHTML.toLowerCase()>=text.toLowerCase())
				return i;
     		 }
	}else
	{
		if (option=='descending')
			for (i=1;i<lastRow;i++)
     		 {
      			if (tbl.rows[i].cells[0].innerHTML.toLowerCase()<=text.toLowerCase())
				return i;
     		 }
	}

     return lastRow;		
}


// Not used yet, if case insensitive in sort, it will be used
function ConvertToUppercase(text)
{
	
	for(i=0; i<text.length; i++)
	{
	  if(text[i]<='z' && text[i]>='a')
                   text[i]  = text[i].toUpperCase();
      	}
	
	return text;
}