
IMSS_HOME=/opt/trend/imss
LD_LIBRARY_PATH=$IMSS_HOME/lib
IMSS_UI_HOME=$IMSS_HOME/UI
JAVA_HOME=$IMSS_UI_HOME/javaJRE
KRB5_CONFIG=$IMSS_HOME/config/krb5.conf
LANG=
SYS=`uname -s`

export KRB5_CONFIG
export IMSS_HOME
export LD_LIBRARY_PATH
export JAVA_HOME
export LANG

IMSS_DB_DIR="postgresql"
IMSS_DB_INI="database.ini"
IMSS_DB_TYPE="postgresql"
ODBCINI=$IMSS_HOME/config/odbc.ini
ODBCSYSINI=$IMSS_HOME/config

export IMSS_DB_DIR
export IMSS_DB_INI
export IMSS_DB_TYPE
export ODBCINI
export ODBCSYSINI

PS_CMD="ps -ef --width 1000"

CATALINA_HOME=$IMSS_UI_HOME/tomcat
DAEMON_HOME=$IMSS_UI_HOME/tomcat
ADMIN_HOME=$IMSS_UI_HOME/adminUI
TOMCAT_USER=jakarta
TMP_DIR=/var/tmp
CATALINA_OPTS=
CLASSPATH=$CATALINA_HOME/bin/bootstrap.jar
CATALINA_PID=$ADMIN_HOME/bin/admin.pid

case "$1" in
  'start')
    if [ -f $CATALINA_PID ]; then
        PID=`cat $CATALINA_PID`
            IMSS_EXIST=`$PS_CMD | grep $PID | grep java | grep -v grep`
        if test "$IMSS_EXIST"
        then
            echo "Central Controller is running."
			# fix tracker IMSA-7.0-00967
			if [ -f /etc/trend-release ]; then
				if [ -f /etc/conf/serviceflag ]; then
					rm /etc/conf/serviceflag >/dev/null 2>&1
				fi
			fi
            exit 1
        fi
    fi
    
    touch $IMSS_HOME/log/catalina.out
    #
    # Start Tomcat
    #
    cd $DAEMON_HOME
    if test $SYS = "SunOS" ; then
        LD_PRELOAD=/usr/lib/libCstd.so.1
        export LD_PRELOAD
    fi
    $JAVA_HOME/bin/java $JAVA_OPTS $CATALINA_OPTS \
      -Djava.endorsed.dirs="$JAVA_ENDORSED_DIRS" -classpath "$CLASSPATH" \
      -Dcatalina.base="$CATALINA_BASE" \
      -Dcatalina.home="$CATALINA_HOME" \
      -Djava.io.tmpdir="$TMP_DIR" \
      -Xss2M \
      org.apache.catalina.startup.Bootstrap -config $ADMIN_HOME/conf/server.xml start\
      >> $IMSS_HOME/log/catalina.out 2>&1 &
      
    if [ ! -z "$CATALINA_PID" ]; then
        echo $! > $CATALINA_PID
    fi

    echo "Central Controller has started."
     
	# fix tracker IMSA-7.0-00967
	if [ -f /etc/trend-release ]; then
		if [ -f /etc/conf/serviceflag ]; then
			rm /etc/conf/serviceflag >/dev/null 2>&1
		fi
	fi

    #
    # To get a verbose JVM
    #-verbose \
    # To get a debug of jsvc.
    #-debug \
    ;;
    
  'stop')
    #
    # Stop Tomcat
    #
    if [ -f $CATALINA_PID ]; then
        PID=`cat $CATALINA_PID`
            IMSS_EXIST=`$PS_CMD | grep $PID | grep java | grep -v grep`
        if test "$IMSS_EXIST"
        then
            kill -TERM $PID

            COUNT=0
            while $PS_CMD | grep -w java | grep -w adminUI | grep -v grep > /dev/null 2>&1 ; do
                sleep 1
                COUNT=`expr $COUNT + 1`
                if test "$COUNT" = "30"
                then
                    for i in `$PS_CMD | grep -w java | grep -w adminUI | grep -v grep | awk '{ print $2 }'`
                    do
                        echo "Force to kill $i ..."
                        kill -KILL $i
                    done
                    break
                fi
            done  
        else
            echo "Central Controller is not started."
        fi
        rm -f $CATALINA_PID
    else
        echo "Central Controller is not started."
    fi

    echo "Central Controller stopped."
    
    ;;
    
  'restart')
    if [ -f $CATALINA_PID ]; then
        PID=`cat $CATALINA_PID`
            IMSS_EXIST=`$PS_CMD | grep $PID | grep java | grep -v grep`
        if test "$IMSS_EXIST"
        then
            kill -TERM $PID

            COUNT=0
            while $PS_CMD | grep -w java | grep -w adminUI | grep -v grep > /dev/null 2>&1 ; do
                sleep 1
                COUNT=`expr $COUNT + 1`
                if test "$COUNT" = "30"
                then
                    for i in `$PS_CMD | grep -w java | grep -w adminUI | grep -v grep |  awk '{ print $2 }'`
                    do
                        echo "Force to kill $i ..."
                        kill -KILL $i
                    done
                    break
                fi
            done  
        fi
    fi
  
    touch $IMSS_HOME/log/catalina.out
    #
    # Start Tomcat
    #
    cd $DAEMON_HOME
    if test $SYS = "SunOS" ; then
        LD_PRELOAD=/usr/lib/libCstd.so.1
        export LD_PRELOAD
    fi
    $JAVA_HOME/bin/java $JAVA_OPTS $CATALINA_OPTS \
      -Djava.endorsed.dirs="$JAVA_ENDORSED_DIRS" -classpath "$CLASSPATH" \
      -Dcatalina.base="$CATALINA_BASE" \
      -Dcatalina.home="$CATALINA_HOME" \
      -Djava.io.tmpdir="$TMP_DIR" \
      -Xss2M \
      org.apache.catalina.startup.Bootstrap -config $ADMIN_HOME/conf/server.xml start\
      >> $IMSS_HOME/log/catalina.out 2>&1 &
      
    if [ ! -z "$CATALINA_PID" ]; then
        echo $! > $CATALINA_PID
    fi
    
    echo "Central Controller restarted."
    ;;
  *)
    echo "Usage tomcat.sh start/stop/restart"
    exit 1;;
esac
