if [ -f /etc/trend-release ]; then
IMSS_HOME=/opt/trend/imss
else
IMSS_HOME=/opt/trend/imss
fi

IMSS_UI_HOME=$IMSS_HOME/UI
LD_LIBRARY_PATH=$IMSS_UI_HOME/apache/lib:$IMSS_HOME/lib
HTTPD=$IMSS_UI_HOME/apache/bin/httpd
IMSS_DB_INI="database.ini"
IMSS_DB_TYPE="postgresql"
IMSS_DB_DIR="postgresql"
KRB5_CONFIG=$IMSS_HOME/config/krb5.conf
ODBCSYSINI=$IMSS_HOME/config
ODBCINI=$IMSS_HOME/config/odbc.ini

export IMSS_HOME
export LD_LIBRARY_PATH
export ODBCSYSINI
export ODBCINI
export IMSS_DB_INI
export IMSS_DB_TYPE
export IMSS_DB_DIR
export KRB5_CONFIG

ARGV="$@"

ERROR=0
PS_CMD="ps -ef"
PIDFILE="/opt/trend/imss/UI/euqUI/bin/httpd.pid"

replace_ip()
{
    if [ -f /etc/conf/ggb.conf ] ; then
        REALADDR=`/opt/TrendMicro/GoldenGate/bin/glcfg /etc/conf/ggb.conf val data_port ip`
    else
        REALADDR=`ifconfig -a|grep -v "127.0.0.1"|grep inet|awk -F' ' '{print $2}'|awk -F: '{print $2}' |head -1`
    fi
    
    FILE=$IMSS_UI_HOME/euqUI/conf/EUQ.conf
    if [ -f $FILE ] ; then
        cp -f $FILE $FILE.bak
        sed -e "s/ServerName.*/ServerName $REALADDR/g" -e "s/<VirtualHost.*/<VirtualHost $REALADDR:8447>/g" $FILE.bak > $FILE
        rm -f $FILE.bak
    fi
}

start()
{
    # check if httpd is running
    if [ -f $PIDFILE ] ; then
        PID=`cat $PIDFILE`
        if [ ! -z $PID ] ; then
            $PS_CMD | grep -w $PID | grep -v grep | grep -w $HTTPD > /dev/null 2>&1
            if [ $? -eq 0 ] ; then
                echo "Apache is running"
                exit 1
            fi
        fi
        rm $PIDFILE
    fi

    $IMSS_HOME/bin/euqutil -e
    replace_ip
    $HTTPD -f $IMSS_UI_HOME/euqUI/conf/EUQ.conf -k start
    ERROR=$?
}

stop()
{
    if [ ! -f $PIDFILE ] ; then
        PID=`$PS_CMD | grep -w $HTTPD | grep -v grep | grep root | awk '{ print $2 }'`
        if [ ! -z $PID ] ; then
            echo $PID > $PIDFILE
        fi
    fi
    $IMSS_HOME/bin/euqutil -e
    replace_ip
    $HTTPD -f $IMSS_UI_HOME/euqUI/conf/EUQ.conf -k stop
    COUNT=0
    while $PS_CMD | grep -w $HTTPD | grep -v grep > /dev/null 2>&1 ; do
        COUNT=`expr $COUNT + 1`
        if test "$COUNT" = "30"
        then
            for i in `$PS_CMD | grep -w $HTTPD | grep -v grep | awk '{ print $2 }'`
            do
                echo "Force to kill $i ..."
                kill -KILL $i
            done
            rm -f $PID_FILE
            break
        fi
        sleep 1
    done
}

if [ -f /etc/trend-release ]; then
	case $ARGV in
	start)
	    start
	    ;;
	restart)
	    stop
	    start
	    ;;
	graceful)
	    $IMSS_HOME/bin/euqutil -e
	    replace_ip
	    $HTTPD -f $IMSS_UI_HOME/euqUI/conf/EUQ.conf -k $ARGV
	    ERROR=$?
	    ;;
	stop)
	    stop
	    ;;
	*)
	    echo "Usage Apache.sh start/stop"
	    ERROR=1;;
	esac
else
	case $ARGV in
	start|stop|restart|graceful)
	    $HTTPD -f $IMSS_UI_HOME/euqUI/conf/EUQ.conf -k $ARGV
	    ERROR=$?
	    ;;
	*)
	    echo "Usage Apache.sh start/stop/restart"
	    ERROR=1;;
	esac
fi
exit $ERROR
