if [ -f /etc/trend-release ]; then
	IMSS_HOME=/opt/trend/imss
	PS_CMD="ps -ef --width 1000"
else
	IMSS_HOME=/opt/trend/imss
	PS_CMD="ps -ef --width 1000"
	
fi

LD_LIBRARY_PATH=$IMSS_HOME/lib
IMSS_UI_HOME=$IMSS_HOME/UI
JAVA_HOME=$IMSS_UI_HOME/javaJRE
IMSS_DB_INI="database.ini"
IMSS_DB_TYPE="postgresql"
IMSS_DB_DIR="postgresql"
KRB5_CONFIG=$IMSS_HOME/config/krb5.conf
ODBCSYSINI=$IMSS_HOME/config
ODBCINI=$IMSS_HOME/config/odbc.ini

SYS=`uname -s`

export ODBCSYSINI
export ODBCINI
export IMSS_DB_INI
export IMSS_DB_TYPE
export IMSS_DB_DIR
export KRB5_CONFIG
export IMSS_HOME
export LD_LIBRARY_PATH
export JAVA_HOME

if [ "$LANG" = "" ];then
  LANG=
  export LANG
fi




CATALINA_HOME=$IMSS_UI_HOME/tomcat
DAEMON_HOME=$IMSS_UI_HOME/tomcat
EUQ_HOME=$IMSS_UI_HOME/euqUI
TOMCAT_USER=jakarta
TMP_DIR=/var/tmp
CATALINA_OPTS=
CLASSPATH=$CATALINA_HOME/bin/bootstrap.jar
CATALINA_PID=$EUQ_HOME/bin/euq.pid

SCANNERID=

getScannerID()
{
   configdir=$IMSS_HOME/config
   SCANNERID=`grep "scanner_id" $configdir/imss.ini 2>/dev/null|grep -v "^#" | awk -F= '{print $2}'`
   if [ "$SCANNERID" = "" ]; then
      SCANNERID=0
   fi
}

Replace_EUQ_INFO()
{
    getScannerID
    if [ "$SCANNERID" -eq 0 ]; then
        echo "This server can not start EUQ because the scanner_id is equal to 0."
        exit 1
    fi

    sed -e "s,jvmRoute=\".*\",jvmRoute=\"euq$SCANNERID\",g" $IMSS_HOME/UI/euqUI/conf/server.xml > $IMSS_HOME/temp/pp$$
    cp $IMSS_HOME/temp/pp$$ $IMSS_HOME/UI/euqUI/conf/server.xml
    rm -f $IMSS_HOME/temp/pp*
}

case "$1" in
  'start')
    if [ -f /etc/trend-release ]; then
    	# we need to change server.xml for load balance
    	Replace_EUQ_INFO
    fi
    if [ -f $CATALINA_PID ]; then
        PID=`cat $CATALINA_PID`
            IMSS_EXIST=`$PS_CMD | grep $PID | grep java | grep -v grep`
        if test "$IMSS_EXIST"
        then
            echo "EUQ is running."
            exit 1
        fi
    fi
    if [ -f /etc/trend-release ]; then
    	$IMSS_HOME/bin/euqop clear
    fi
    $IMSS_HOME/bin/euqutil -e

    if [ $? -ne 0 ]; then
        echo "Get euq db setting information failed"
        exit 1
    fi
    
    ODBCINI=$IMSS_HOME/config/euqodbc.ini
    export ODBCINI
  
    touch $IMSS_HOME/log/catalina.out
    #
    # Start Tomcat
    #
    cd $DAEMON_HOME
    if test $SYS = "SunOS" ; then
        LD_PRELOAD=/usr/lib/libCstd.so.1
        export LD_PRELOAD
    fi
    $JAVA_HOME/bin/java $JAVA_OPTS $CATALINA_OPTS \
      -Djava.endorsed.dirs="$JAVA_ENDORSED_DIRS" -classpath "$CLASSPATH" \
      -Dcatalina.base="$CATALINA_BASE" \
      -Dcatalina.home="$CATALINA_HOME" \
      -Djava.io.tmpdir="$TMP_DIR" \
      -Xss2M \
      org.apache.catalina.startup.Bootstrap -config $EUQ_HOME/conf/server.xml start\
      >> $IMSS_HOME/log/catalina.out 2>&1 &
      
#    if [ ! -z "$CATALINA_PID" ]; then
        echo $! > $CATALINA_PID
#    fi
      
    #
    # To get a verbose JVM
    #-verbose \
    # To get a debug of jsvc.
    #-debug \
    ;;
    
  'stop')
    #
    # Stop Tomcat
    #
    if [ -f $CATALINA_PID ]; then
        PID=`cat $CATALINA_PID`
            IMSS_EXIST=`$PS_CMD | grep $PID | grep java | grep -v grep`
        if test "$IMSS_EXIST"
        then
            kill -TERM $PID

            COUNT=0
            while $PS_CMD | grep -w java | grep -w euqUI | grep -v grep > /dev/null 2>&1 ; do
                sleep 1
                COUNT=`expr $COUNT + 1`
                if test "$COUNT" = "30"
                then
                    for i in `$PS_CMD | grep -w java | grep -w euqUI | grep -v grep | awk '{ print $2 }'`
                    do
                        echo "Force to kill $i ..."
                        kill -KILL $i
                    done
                    break
                fi
            done  
        else
            echo "EUQ is not started."
        fi
        rm -f $CATALINA_PID
    else
        echo "EUQ is not started."
    fi
    ;;
  'restart')
    if [ -f $CATALINA_PID ]; then
        PID=`cat $CATALINA_PID`
            IMSS_EXIST=`$PS_CMD | grep $PID | grep java | grep -v grep`
        if test "$IMSS_EXIST"
        then
            kill -TERM $PID

            COUNT=0
            while $PS_CMD | grep -w java | grep -w euqUI | grep -v grep > /dev/null 2>&1 ; do
                sleep 1
                COUNT=`expr $COUNT + 1`
                if test "$COUNT" = "30"
                then
                    for i in `$PS_CMD | grep -w java | grep -w euqUI | grep -v grep |  awk '{ print $2 }'`
                    do
                        echo "Force to kill $i ..."
                        kill -KILL $i
                    done
                    break
                fi
            done  
        fi
    fi
	if [ -f /etc/trend-release ]; then    
	    # we need to change server.xml for load balance
	    Replace_EUQ_INFO
    fi

    $IMSS_HOME/bin/euqutil -e

    if [ $? -ne 0 ]; then
        echo "Get euq db setting information failed"
        exit 1
    fi
    
    ODBCINI=$IMSS_HOME/config/euqodbc.ini
    export ODBCINI
  
    touch $IMSS_HOME/log/catalina.out
    #
    # Start Tomcat
    #
    cd $DAEMON_HOME
    if test $SYS = "SunOS" ; then
        LD_PRELOAD=/usr/lib/libCstd.so.1
        export LD_PRELOAD
    fi
    $JAVA_HOME/bin/java $JAVA_OPTS $CATALINA_OPTS \
      -Djava.endorsed.dirs="$JAVA_ENDORSED_DIRS" -classpath "$CLASSPATH" \
      -Dcatalina.base="$CATALINA_BASE" \
      -Dcatalina.home="$CATALINA_HOME" \
      -Djava.io.tmpdir="$TMP_DIR" \
      -Xss2M \
      org.apache.catalina.startup.Bootstrap -config $EUQ_HOME/conf/server.xml start\
      >> $IMSS_HOME/log/catalina.out 2>&1 &
      
#    if [ ! -z "$CATALINA_PID" ]; then
        echo $! > $CATALINA_PID
#    fi
    
    ;;
  *)
    echo "Usage tomcat.sh start/stop/restart"
    exit 1;;
esac

