#!/bin/sh
PATH=/sbin:/usr/sbin:/bin:/usr/bin:$PATH
export PATH
LD_LIBRARY_PATH=/opt/trend/imss/bind
export LD_LIBRARY_PATH
PS_CMD="ps -ef --width 1000"
BIND_BASE=/opt/trend/imss/bind

PIDPATH=/var/run/named
EXE_NAME=named
EXECUTE="$BIND_BASE/named"
EXESTOP="$BIND_BASE/rndc stop"

usage()
{
	echo "$0 <start|stop>"
	exit 1
}

start()
{
    mkdir -p $PIDPATH
    chmod 770 $PIDPATH
    chown named:named  $PIDPATH
    
    for i in `$PS_CMD | grep -w $EXE_NAME | grep -v grep | grep -v defunct |grep -v named.pid | awk '{ print $2 }'`
    do 
        if test -n "$i"
        then 
            echo "$EXE_NAME is running."
            exit 0
        fi
    done 
    if test -x $EXECUTE ; then
        $EXECUTE -u named
        sleep 1
        for i in `$PS_CMD | grep -w $EXE_NAME | grep -v grep| grep -v named.pid | awk '{ print $2 }'`
        do 
            if test -n "$i"
            then 
                echo "$EXE_NAME has started."
                exit 0
            fi
        done 
        echo "$EXE_NAME cannot be started."
        exit 1
    else
        echo "$EXE_NAME is not executable."
        exit 1
    fi
}

stop()
{
    EXE_EXIST=`$PS_CMD |grep -w $EXE_NAME | grep -v grep|grep -v named.pid `
    if test -n "$EXE_EXIST"
    then
        echo "$EXE_NAME is stopping."
        $EXESTOP
        sleep 1
        for i in `$PS_CMD |grep -w $EXE_NAME|grep -v grep |grep -v named.pid |awk '{print $2}'`
        do
      	    kill -KILL $i
        done
        sleep 1
        for i in `$PS_CMD |grep -w $EXE_NAME|grep -v grep |grep -v named.pid |awk '{ print $2}'`
        do
            if test -n "$i"
            then 
                echo "$EXE_NAME can't be stoped."
                exit 1
            fi
        done
        exit 0
    else
        echo "$EXE_NAME is not running."
    fi
}

case "$1" in
    'start')
            start;;

     'stop')
            stop;;
          *)
            usage;;
esac
