#!/bin/sh
PATH=/sbin:/usr/sbin:/bin:/usr/bin:$PATH
export PATH

SYS=`uname -s`
if test $SYS = "Linux" ; then 
    PS_CMD="ps -ef --width 1000"
else
    PS_CMD="ps -ef"
fi

IMSS_HOME=$1
LD_LIBRARY_PATH=$IMSS_HOME/lib
export IMSS_HOME
export LD_LIBRARY_PATH

IMSSD=$IMSS_HOME/script/S99IMSS
POLICY=$IMSS_HOME/script/S99POLICY
MONITOR=$IMSS_HOME/script/S99MONITOR
MANAGER=$IMSS_HOME/script/S99MANAGER
CMAGENT=$IMSS_HOME/script/S99CMAGENT
ADMINUI=$IMSS_HOME/script/S99ADMINUI
EUQ=$IMSS_HOME/script/S99EUQ

ctl_stop_list="
    $MONITOR imssmgrmon\
    $MANAGER imssmgr\
    $IMSSD imssd\
    $CMAGENT imsscmagent\
    $POLICY imssps\
    $ADMINUI adminUI/conf/server.xml\
    $EUQ euqUI/conf/server.xml\
"

ctl_start_list="
    $ADMINUI adminUI/conf/server.xml\
    $EUQ euqUI/conf/server.xml\
    $POLICY imssps\
    $IMSSD imssd\
    $MONITOR imssmgrmon\
    $CMAGENT imsscmagent\
"

serv_info_file=$IMSS_HOME/cdt/.serv_info

start()
{
    echo "===== start imss services ====="
    fname_complete=0
    for i in $ctl_start_list
    do
    if [ $fname_complete -eq 0 ]; then
      fname=$i
      fname_complete=1
    else
      needstart=`cat $serv_info_file | grep -w $fname`
      if [ "${needstart}" != "" ]; then
        if [ -f ${fname} ]; then
          $PS_CMD | grep -w $i | grep -v grep > /dev/null
          if [ $? != 0 ] ; then
            echo "start imss service $fname ..."
            $fname start
          else
            echo "imss service $fname has been started."
          fi
        else
          echo "imss service $fname not found."
        fi 
      fi
      fname_complete=0
    fi  
    done
    rm -rf $serv_info_file
}

stop()
{
    rm -rf $serv_info_file
    echo "===== stop imss services ====="
    fname_complete=0
    sevice_list=""
    for i in $ctl_stop_list
    do
    if [ $fname_complete -eq 0 ]; then
      fname=$i
      fname_complete=1
    else
      if [ -f ${fname} ]; then
        $PS_CMD | grep -w $i | grep -v grep > /dev/null
        if [ $? = 0 ] ; then
          service_list="$service_list $fname"
          echo "stop imss service $fname ..."
          $fname stop
        else
          echo "imss service $fname not started."
        fi
      else
        echo "imss service $fname not found."
      fi
      fname_complete=0
    fi  
    done
    echo "$service_list" > $serv_info_file
}

case "$2" in
'start') 
      start
      ;; 

'stop')
      stop
      ;;
'restart')
      stop
      start
      ;;
*)
    echo "usage: $0 start|stop|restart"
    exit 1
    ;;
esac
exit 0
