#!/bin/sh
PATH=/sbin:/usr/sbin:/bin:/usr/bin:$PATH
export PATH

PS_CMD="ps -ef --width 1000"

IMSS_HOME=/opt/trend/imss
export IMSS_HOME

LD_LIBRARY_PATH=$IMSS_HOME/lib
IMSS_DB_DIR=postgresql
IMSS_DB_INI=database.ini
ODBCINI=$IMSS_HOME/config/odbc.ini
ODBCSYSINI=$IMSS_HOME/config

export LD_LIBRARY_PATH
export IMSS_DB_DIR
export IMSS_DB_INI
export ODBCINI
export ODBCSYSINI

trap "" SIGINT
trap "unlock" EXIT

. $IMSS_HOME/script/imssfunctions

lock

$IMSS_HOME/bin/euqutil -odbc

if [ $? -ne 0 ]; then
  echo "Get euq db setting information failed"
  exit 0
fi

ODBCINI=$IMSS_HOME/config/transodbc.ini
export ODBCINI

$IMSS_HOME/bin/euqutil -removeall

