#! /bin/bash

IMSS_HOME=/opt/trend/imss
export IMSS_HOME

LD_LIBRARY_PATH=/opt/trend/imss/lib:/opt/trend/imss/bin/migration
export LD_LIBRARY_PATH

trap "" SIGINT
trap "unlock" EXIT

. $IMSS_HOME/script/imssfunctions

lock

EXE_NAME=imp_exp

Usage()
{
    echo "usage: `basename $0` option filename [import_result_filename] result_filename"
    echo " option:"
    echo "   -e: export"
    echo "   -i: import"
    echo " file_name"
    echo "   it specify the import/export file full path name"
    echo " result_filename"
    echo "   when import, it specifies where to save the import result"
    echo " result_file"
    echo "   it specify where to save the result code"
}

case "$1" in
'-e')
    $IMSS_HOME/bin/$EXE_NAME $1 $2 $3
    ;;

'-i')
    $IMSS_HOME/bin/$EXE_NAME $1 $2 $3 $4
    ;;
    
*)
    Usage
    exit 1
    ;;
esac
