#! /bin/bash

# vim:shiftwidth=4:tabstop=4:expandtab

IMSS_HOME=/opt/trend/imss

export PATH=/sbin:/usr/sbin:/bin:/usr/bin:$PATH:$IMSS_HOME/postfix/usr/sbin/:$IMSS_HOME/postfix/usr/bin/:$IMSS_HOME/postfix/usr/libexec/postfix

MONITOR=$IMSS_HOME/script/S99MONITOR
DB=$IMSS_HOME/script/dbctl.sh
POSTFIX=$IMSS_HOME/script/postfix
ADMINUI=$IMSS_HOME/script/S99ADMINUI
CMAGENT=$IMSS_HOME/script/S99CMAGENT
POLICY=$IMSS_HOME/script/S99POLICY
IMSS=$IMSS_HOME/script/S99IMSS
FOXDNS=$IMSS_HOME/script/S99FOXDNS
BIND=$IMSS_HOME/bind/bindctl.sh
SCHEDULED=$IMSS_HOME/script/S99SCHEDULED
MANAGER=$IMSS_HOME/script/S99MANAGER
DB=$IMSS_HOME/script/dbctl.sh
MSGACTION=$IMSS_HOME/script/msgaction.sh
POSTFIX=$IMSS_HOME/script/postfix
RTSTAT=$IMSS_HOME/script/rtstat.sh
MAILTRAFFIC=$IMSS_HOME/script/mailtraffic.sh
ADMINUI=$IMSS_HOME/script/S99ADMINUI
CMAGENT=$IMSS_HOME/script/S99CMAGENT
APACHE=$IMSS_HOME/script/Apache.sh
TOMCAT=$IMSS_HOME/script/S99EUQ
POLICY=$IMSS_HOME/script/S99POLICY
IMSS=$IMSS_HOME/script/S99IMSS
FOXDNS=$IMSS_HOME/script/S99FOXDNS
BIND=$IMSS_HOME/bind/bindctl.sh
FOXPROXY=/opt/trend/ipprofiler/script/foxproxyd
SCHEDULED=$IMSS_HOME/script/S99SCHEDULED
UPDATE=$IMSS_HOME/script/S99UPDATE
EUQ=$IMSS_HOME/script/S99EUQ
# for generate timezone script
GENTZD=$IMSS_HOME/script/gentzd.sh
TZDFILE=$IMSS_HOME/UI/adminUI/ROOT/javascripts/tzd.js

trap "" SIGINT
trap "unlock" EXIT

. $IMSS_HOME/script/imssfunctions

lock

start()
{
    if [ -f /etc/trend-release ]; then
        $MONITOR start
        sh $GENTZD > $TZDFILE
        chown imss $TZDFILE
        chgrp imss $TZDFILE
        chmod 750 $TZDFILE
        if [ -d /var/queue_temp/ ] ; then
            /opt/trend/imss/bin/close_handle_sh "nohup rm -rf /var/queue_temp/ > /dev/null 2>&1 &"
        fi
    else
        $DB start
        start_others
    fi
}
stop_others()
{
    $MONITOR stop
    $MANAGER stop
    $MSGACTION stop
    $RTSTAT stop
    $MAILTRAFFIC stop
    $CMAGENT stop
    $APACHE stop
    $TOMCAT stop
    $FOXPROXY stop
    $POSTFIX stop
    $IMSS stop
    $BIND stop
    $FOXDNS stop
    $POLICY stop
    $SCHEDULED stop
    $UPDATE stop
}
stop_others_hang()
{
    $MANAGER stop
    $MSGACTION stop
    $RTSTAT stop
    $MAILTRAFFIC stop
    $CMAGENT stop
    $FOXPROXY stop
    $IMSS stop
    $FOXDNS stop
    $POLICY stop
    $SCHEDULED stop
    $UPDATE stop
}

stop()
{
    if [ -f /etc/trend-release ]; then
        stop_others
        $ADMINUI stop
        $DB stop
    else
        $MONITOR stop
        $EUQ stop
        $POLICY stop
        $IMSS stop
        $BIND stop
        $FOXDNS stop
        $SCHEDULED stop
        $ADMINUI stop
        $CMAGENT stop
        $POSTFIX stop
        $DB stop
    fi
}
restart_others()
{
    sleep 5
    stop_others
    $DB reload
    start
}

start_others()
{
    $POSTFIX start
    $CMAGENT start
    $ADMINUI start
    $SCHEDULED start
    $FOXDNS start
    $BIND start
    $IMSS start
    $POLICY start
    $EUQ start
    $MONITOR start
}

case "$1" in
    start)
        start
        ;;
    stop)
        stop
        ;;
    stop_others)
        stop_others
        ;;
    stop_others_hang)
        stop_others_hang
        ;;
    start-others)
        start_others
        ;;
    restart)
        stop
        start
        ;;
    restart_others)
    	restart_others
    	;;
    *)
        echo $0 "start|stop|stop_others|restart|restart_others"
esac
