#!/bin/sh

trap "" SIGINT
trap "unlock" EXIT

. $IMSS_HOME/script/imssfunctions

lock

# remove all files under folder which is not accessed today.
# the first parameter must be absolute direction.

CURRENT_MON=$(date | awk '{print $2}')
CURRENT_DATE=$(date | awk '{print $3}')

parm_index=0
total_num=$#

# get each file, compare last access time with current time, rm all not today
while [ $parm_index -lt $total_num ]
do
    DIRECTION=$1
    
    if [ -d $DIRECTION ]; then
        TOTAL_FILE=$(ls $DIRECTION)

        for i in $TOTAL_FILE; do
            FILE_NAME=$DIRECTION/$i
            MON=$(ls -lut $FILE_NAME | awk '{print $6}')
            DATE=$(ls -lut $FILE_NAME | awk '{print $7}')

            if [ "$MON" != "$CURRENT_MON" -o "$DATE" != "$CURRENT_DATE" ]; then
                rm -Rf $FILE_NAME
                echo "rm -Rf $FILE_NAME"
            fi
        done
    else
        echo "$DIRECTION is not a directory, just ignore it!"
    fi
    
    parm_index=$[$parm_index+1]
    shift
done

