#!/bin/sh
PATH=/sbin:/usr/sbin:/bin:/usr/bin:$PATH
export PATH

IMSS_HOME=/opt/trend/imss
LD_LIBRARY_PATH=$IMSS_HOME/lib
export IMSS_HOME
export LD_LIBRARY_PATH
ODBCINI=$IMSS_HOME/config/odbc.ini
export ODBCINI
ODBCSYSINI=$IMSS_HOME/config/
export ODBCSYSINI
DBINI=$IMSS_HOME/config/database.ini
export DBINI
TESTDB=$IMSS_HOME/bin/testdb

trap "" SIGINT
trap "unlock" EXIT

. $IMSS_HOME/script/imssfunctions

lock

usage()
{
	echo "$0 <reg|unreg>"
	exit
}

getaddr()
{
	echo "Please specify the ip address of the machine which installed the ipprofiler:"
    read REALADDR
}

setup_db()
{   
    DBUSER=`grep "UserId" $DBINI | awk -F= '{print $2}'`
    DBUSERPASS=`grep "Password" $DBINI | awk -F= '{print $2}'`
    DBNAME=`grep "Database=" $DBINI | awk -F= '{print $2}'`	
}

register()
{
	setup_db
	STATUS=0203030303
	getaddr
    $TESTDB 12 IMSS "$DBUSER" "/P $DBUSERPASS" "$DBNAME" "$REALADDR" "$STATUS" >/dev/null 2>&1
    if [ $? -eq 0 ]; then
        Message="The ipprofiler has been registered successfully"
    else
        Message="The ipprofiler has not been registerd"
    fi
    echo "$Message"
}

unregister()
{
	setup_db
	STATUS=0003030303
	getaddr
    $TESTDB 13 IMSS "$DBUSER" "/P $DBUSERPASS" "$DBNAME" "$REALADDR" "$STATUS" >/dev/null 2>&1
    if [ $? -eq 0 ]; then
        Message="The ipprofiler has been unregistered successfully"
    else
        Message="The ipprofiler has not been unregistered"
    fi
    echo "$Message"
}

case "$1" in
  'reg')
	   register;;
'unreg')
	   unregister;;
      *)
	   usage;;
esac



