SET client_encoding = 'LATIN9';
SET check_function_bodies = false;
SET client_min_messages = warning;

CREATE TABLE tb_euq_main
(
  user_name varchar(256),
  table_id int4,
  user_id serial NOT NULL ,
  auto_add int4 DEFAULT 0,
  pattern_info int4 DEFAULT 0,
  mode int4 DEFAULT 0
);

CREATE TABLE tb_euq_whitelist
(
  user_id int4 NOT NULL,
  email varchar(256) NOT NULL,
  time_date timestamptz,
  hash int4,
  pattern_type int4 DEFAULT 0
  
) ;

CREATE TABLE tb_msg_action
(
  msg_id char(36) NOT NULL,
  scanner_id int4 NOT NULL,
  msg_action int2,
  area_id varchar(256),
  time_date timestamptz,
  msg_owner varchar(256),
  user_id int4 NOT NULL
);

ALTER TABLE ONLY tb_euq_main
    ADD CONSTRAINT pk_tb_euq_main PRIMARY KEY (user_id);

CREATE INDEX idx_tb_euq_main_username
  ON tb_euq_main
  USING btree
  (user_name);

ALTER TABLE ONLY tb_euq_whitelist
    ADD CONSTRAINT pk_whitelist PRIMARY KEY (user_id, email);
    
ALTER TABLE ONLY tb_euq_whitelist
    ADD CONSTRAINT fk_whitelist FOREIGN KEY (user_id) REFERENCES tb_euq_main (user_id) ON UPDATE RESTRICT ON DELETE RESTRICT;

ALTER TABLE ONLY tb_msg_action    
    ADD CONSTRAINT pk_msg_action PRIMARY KEY (user_id, msg_id, scanner_id);


CREATE OR REPLACE FUNCTION CreateEuqTables(int) RETURNS int AS '
DECLARE
    nCreateNum  ALIAS FOR $1;
    nTmp        int;
    szSQL       varchar(256);
BEGIN
    nTmp := 0;
    WHILE nCreateNum > nTmp LOOP
        szSQL := ''CREATE TABLE tb_euq_spam'' || nTmp || ''(
  user_id int4,
  scanner_id int4,
  msg_id char(36) NOT NULL,
  one_rcpt varchar(256),
  subject varchar(256),
  msg_size float8,
  area_id varchar(256),
  time_date timestamptz,
  sender varchar(256)
        );'';
        EXECUTE szSQL;
        
        szSQL := ''CREATE INDEX idx_spam'' || nTmp || '' ON tb_euq_spam'' || nTmp || '' USING btree (user_id, time_date);'';
        EXECUTE szSQL;
        nTmp := nTmp + 1;
    END LOOP;
    RETURN 0;
END;
' LANGUAGE plpgsql;

select CreateEuqTables(128);
