CREATE OR REPLACE FUNCTION CleanupReportResultFile (int, int, int, int) RETURNS SETOF RECORD AS '
DECLARE
    rec_ticket		RECORD;
    rec_file		RECORD;
	nDaily			ALIAS FOR $1;
	nWeekly			ALIAS FOR $2;
	nMonthly		ALIAS FOR $3;
	nOnetime		ALIAS FOR $4;
	cut				int;
	cnt				int;
	sql				varchar(512);
	rowCount		int;
	v_tablename		varchar(50);
	v_report		record;
BEGIN
	select tablename into v_tablename from pg_tables where lower(tablename)=''tmpfiles_imss'';
	get diagnostics rowCount = ROW_COUNT;
	if rowCount = 0 then
		create table tmpFiles_imss (htmlFile varchar(1024), csvFile varchar(1024)) without oids;
	else
		delete from tmpFiles_imss;
	end if;

	/*Daily*/
	select count(report_id) into cnt from tb_report_results where report_type = 1;
	cut := cnt - nDaily;
	if cut > 0 and nDaily >=0 then
		sql := ''insert into tmpFiles_imss (htmlFile, csvFile) Select report_filepath, report_csvpath From tb_report_results Where report_type = 1 Order by create_time Limit '' || cut;
		execute sql;
		FOR v_report IN Select report_id From tb_report_results Where report_type = 1 Order by create_time Limit cut LOOP
		delete from tb_report_results where report_id = v_report.report_id;
		END LOOP;	
	end if;
	
	/*Weekly*/
	select count(report_id) into cnt from tb_report_results where report_type = 2;
	cut := cnt - nWeekly;
	if cut > 0 and nWeekly >=0 then
		sql := ''insert into tmpFiles_imss (htmlFile, csvFile) Select report_filepath, report_csvpath From tb_report_results Where report_type = 2 Order by create_time Limit '' || cut;
		execute sql;
		FOR v_report IN Select report_id From tb_report_results Where report_type = 2 Order by create_time Limit cut LOOP
		delete From tb_report_results Where report_id = v_report.report_id;
		END LOOP;	
	end if;
	
	/*Monthly*/
	select count(report_id) into cnt from tb_report_results where report_type = 3;
	cut := cnt - nMonthly;
	if cut > 0 and nMonthly >=0 then
		sql := ''insert into tmpFiles_imss (htmlFile, csvFile) Select report_filepath, report_csvpath From tb_report_results Where report_type = 3 Order by create_time Limit '' || cut;
		execute sql;
		FOR v_report IN Select report_id From tb_report_results Where report_type = 3 Order by create_time Limit cut LOOP
		delete From tb_report_results Where report_id = v_report.report_id;
		END LOOP;	
	end if;
	
	/*Onetime*/
	sql := ''insert into tmpFiles_imss (htmlFile, csvFile) Select report_filepath, report_csvpath From tb_report_results Where report_type < 0'';
	execute sql;
	FOR v_report IN select report_id, ticket_id, report_type from tb_report_results where report_type < 0 LOOP
	if v_report.report_type = -1 then
	    delete from tb_report_results where ticket_id = v_report.ticket_id;
	    delete from tb_report_tickets where ticket_id = v_report.ticket_id;
	else
	    delete from tb_report_results where report_id = v_report.report_id;
	end if;
	END LOOP;

	for rec_file in select htmlFile, csvFile from tmpFiles_imss loop
		return next rec_file;
	end loop;
    
   return;
END;
' LANGUAGE 'plpgsql' ;